#include <ReArchive/types/Header.h>
#include <cstring>
#include <stdexcept>

std::vector<unsigned char> ReArchive::Header::Serialize(const ReArchive::Header& header) {
    std::vector<unsigned char> result;
    result.insert(result.end(), ReArchive::magic.begin(), ReArchive::magic.end());

    result.push_back(header.use_compression);

    size_t current_size = result.size();
    result.resize(current_size + sizeof(int64_t));
    auto network_file_table_offset = Endianness::HostToNetworkOrder(header.file_table_offset);//htobe64(header.file_table_offset);
    memcpy(result.data() + current_size, &network_file_table_offset, sizeof(int64_t));

    return result;
}

ReArchive::Header ReArchive::Header::DeSerialize(const unsigned char* serialized_header) {
    bool use_c; int64_t file_table_off;

    use_c = serialized_header[ReArchive::magic.size()];
    memcpy(&file_table_off, serialized_header + ReArchive::Header::Size() - sizeof(int64_t), sizeof(int64_t));

    return { use_c, (int64_t) Endianness::HostToNetworkOrder(file_table_off)};//be64toh(file_table_off)};
}
